//package gui;

import java.io.*;
import java.sql.*;
import net.tinyos.packet.*;
import net.tinyos.util.*;
import net.tinyos.message.*;

public class SerialReader implements MessageListener {
	
	static final int AM_SERIALDATA_MSG = 2;
	
	private MoteIF moteIF;
	
	public SerialReader(MoteIF moteIF) {
		this.moteIF = moteIF;
		this.moteIF.registerListener(new SerialDataMsg(), this);
	}
	
	public void messageReceived(int to, Message message) {
		//System.out.println("msg rec");
		int type = message.amType();
		//System.out.println("am type = " + type);
		switch(type) {
			case AM_SERIALDATA_MSG:
				SerialDataMsg datamsg = (SerialDataMsg)message;
				System.out.println("Received Data msg from " + datamsg.get_id() + 
								   " with accelx: " + datamsg.get_accelx() + 
								   ", accely: "+ datamsg.get_accely() +
								   ", rssi: " + datamsg.get_rssi() + 
								   " and counter: " + datamsg.get_counter());
				break;

		}
	}
	
	private static void usage() {
		System.err.println("usage: SerialReader [-comm <source>]");
	}
	
	public static void main(String[] args) throws Exception {
		String source = null;
		if (args.length == 2) {
			if (!args[0].equals("-comm")) {
				usage();
				System.exit(1);
			}
			source = args[1];
		}
		else if (args.length != 0) {
			usage();
			System.exit(1);
		}
		
		PhoenixSource phoenix;
		
		if (source == null) {
			phoenix = BuildSource.makePhoenix(PrintStreamMessenger.err);
		}
		else {
			phoenix = BuildSource.makePhoenix(source, PrintStreamMessenger.err);
		}
		
		MoteIF mif = new MoteIF(phoenix);
		SerialReader client = new SerialReader(mif);
		System.out.println("Started with source: " + source);
		//serial.sendPackets();
	}
}
